--- old/usr/src/cmd/mdb/common/mdb/mdb_nv.c	2013-10-19 13:05:45.198815703 -0400
+++ new/usr/src/cmd/mdb/common/mdb/mdb_nv.c	2013-10-19 13:05:45.204449756 -0400
@@ -38,7 +38,7 @@
 
 #define	NV_SIZE(v) \
 	(((v)->v_flags & MDB_NV_EXTNAME) ? sizeof (mdb_var_t) : \
-	sizeof (mdb_var_t) + MDB_NV_NAMELEN - 1)
+	sizeof (mdb_var_t) + strlen((v)->v_lname))
 
 #define	NV_HASHSZ	211
 
@@ -66,20 +66,24 @@
 nv_var_alloc(const char *name, const mdb_nv_disc_t *disc,
 	uintmax_t value, uint_t flags, uint_t um_flags, mdb_var_t *next)
 {
-	size_t nbytes = (flags & MDB_NV_EXTNAME) ? sizeof (mdb_var_t) :
-	    (sizeof (mdb_var_t) + MDB_NV_NAMELEN - 1);
+	size_t nbytes;
+	mdb_var_t *v;
+
+	if (flags & MDB_NV_EXTNAME)
+		nbytes = sizeof (mdb_var_t);
+	else
+		nbytes = sizeof (mdb_var_t) + strlen(name);
 
-	mdb_var_t *v = mdb_alloc(nbytes, um_flags);
+	v = mdb_alloc(nbytes, um_flags);
 
 	if (v == NULL)
 		return (NULL);
 
 	if (flags & MDB_NV_EXTNAME) {
 		v->v_ename = name;
-		v->v_lname[0] = 0;
+		v->v_lname[0] = '\0';
 	} else {
-		(void) strncpy(v->v_lname, name, MDB_NV_NAMELEN - 1);
-		v->v_lname[MDB_NV_NAMELEN - 1] = '\0';
+		strcpy(v->v_lname, name);
 		v->v_ename = NULL;
 	}
 
